/* $Id: cap_db.h 483 2007-11-20 15:45:54Z pkun $ */

#ifndef _PARSEC_CAPS_DB_H_
#define _PARSEC_CAPS_DB_H_

#include <stdio.h>		/* For FILE */
#include <sys/types.h>		/* For pid_t */

#include <parsec/parsec.h>
#ifdef ASTRA_SE
	#include <parsec/parsec_cap.h>
#endif //ASTRA_SE
#include <parsec/parsec_linux_cap.h>

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************
 *           WORKING WITH CONFIG FILE              *
 ***************************************************/

	struct caps {
		char *name;
#ifdef ASTRA_SE
		parsec_cap_t parsec_caps;
#endif //ASTRA_SE
		linux_cap_t linux_caps;
	};

	struct __cap_han_t;
	typedef struct __cap_han_t *cap_han_t;

	extern struct caps *parse_cap(const char *buff, 
		struct caps *cap);
	extern char *compose_cap(const struct caps *cap);

	// thread-safe base API
	extern cap_han_t opencapdb_r(void);
	extern int closecapdb_r(cap_han_t han);

	extern void freecapent_r(struct caps *cap);
	extern int setcapent_r(cap_han_t han);
	extern int endcapent_r(cap_han_t han);
	extern struct caps *getcapent_r(cap_han_t han);
	extern struct caps *getcapnam_r(cap_han_t han, const char *name);
	extern int putcapent_r(cap_han_t han, const struct caps *data);
	extern int rmcapnam_r(cap_han_t han, const char *name);

	extern struct caps *fgetcapent_r(FILE *f);
	extern int fputcapent_r(FILE *f, const struct caps *data);

	// old common API
	extern int setcapent(void);
	extern void endcapent(void);
	extern struct caps *getcapent(void);
	extern struct caps *getcapnam(const char *name);
	extern int putcapent(const struct caps *data);
	extern struct caps *fgetcapent(FILE *f);
	extern void fputcapent(FILE *f, const struct caps *data);
	extern int rmcapnam(const char *name);

#ifdef __cplusplus
}
#endif

#endif // _PARSEC_CAPS_DB_H_
