/* $Id: cap_db.h 322 2007-06-07 15:36:14Z pkun $ */

#ifndef _PARSEC_WCCAPS_DB_H_
#define _PARSEC_WCCAPS_DB_H_

#include <parsec/cap_db.h>
#include <wchar.h>

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************
 *           WORKING WITH CONFIG FILE              *
 ***************************************************/

	struct wccaps {
		wchar_t *name;
		uint32_t parsec_caps;
		uint32_t linux_caps;
	};

	extern cap_han_t wcopencapdb(void);
	extern int wcclosecapdb(cap_han_t han);
	extern int wcsetcapent(cap_han_t han);
	extern int wcendcapent(cap_han_t han);

	extern int wcfreecapent(struct wccaps *cap);

	extern struct wccaps *wcgetcapent(cap_han_t han);
	extern struct wccaps *wcgetcapnam(cap_han_t han, const wchar_t *name);
	extern int wcputcapent(cap_han_t han, const struct wccaps *data);
	extern struct wccaps *wcfgetcapent(FILE *f);
	extern int wcfputcapent_r(FILE *f, 
		const struct wccaps *data);
	extern int wcrmcapnam(cap_han_t han, const wchar_t *name);
	extern int wcfputcapent(FILE * fd, const struct wccaps *data);
	
#ifdef __cplusplus
}
#endif

#endif // _PARSEC_CAPS_DB_H_
