/* $Id: parsec_cap.h 600 2008-08-06 13:31:23Z gloomy $ */

#ifndef _PARSEC_CAP_H_
#define _PARSEC_CAP_H_

#include <parsec/parsec.h>

#define PARSEC_CAP_TO_MASK(x) (1 << (x))

#define PARSEC_CAP_FILE_CAP  	0	/* 1 */
#define PARSEC_CAP_AUDIT     	1	/* 2 */
#define PARSEC_CAP_SETMAC    	2	/* 4 */
#define PARSEC_CAP_CHMAC     	3	/* 8 */
#define PARSEC_CAP_IGNMACLVL 	4	/* 10 */
#define PARSEC_CAP_IGNMACCAT 	5	/* 20 */
#define PARSEC_CAP_SIG       	6	/* 40 */
#define PARSEC_CAP_UPDATE_ATIME	7	/* 80 */
#define PARSEC_CAP_PRIV_SOCK	8	/* 100 */
#define PARSEC_CAP_READSEARCH	9	/* 200 */
#define PARSEC_CAP_CAP		10	/* 400 */
#define PARSEC_CAP_MAC_SOCK	11	/* 800 */

#define PARSEC_CAP_UNSAFE_SETXATTR	12 /* 1000 */
#define PARSEC_CAP_IGNMACINT		13 /* 2000 */
#define PARSEC_CAP_SUMAC		14 /* 4000 */

#define PARSEC_CAP_FS_MASK \
	( \
		PARSEC_CAP_TO_MASK(PARSEC_CAP_FILE_CAP) | \
		PARSEC_CAP_TO_MASK(PARSEC_CAP_CHMAC) | \
		PARSEC_CAP_TO_MASK(PARSEC_CAP_IGNMACLVL) | \
		PARSEC_CAP_TO_MASK(PARSEC_CAP_IGNMACCAT) | \
		PARSEC_CAP_TO_MASK(PARSEC_CAP_UPDATE_ATIME) | \
		PARSEC_CAP_TO_MASK(PARSEC_CAP_READSEARCH) \
	)

#define parsec_cap_is_fs_cap(c) (PARSEC_CAP_TO_MASK(c) & PARSEC_CAP_FS_MASK)

typedef uint32_t parsec_cap_t;

typedef struct {
	parsec_cap_t cap_effective;
	parsec_cap_t cap_permitted;
	parsec_cap_t cap_inheritable;
} parsec_caps_t;

#ifdef __cplusplus
extern "C" {
#endif
/* parsec capability functions */
	extern int parsec_capset(pid_t pid, const parsec_caps_t *data);
	extern int parsec_capget(pid_t pid, parsec_caps_t * data);

#ifdef __cplusplus
}
#endif
#endif	/* _PARSEC_CAP_H_ */
